import { Inject, Injectable, NotFoundException } from '@nestjs/common';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { Model } from 'mongoose';
import { InjectModel } from '@nestjs/mongoose';
import { {{Name}}Interface } from './models/interfaces/{{inputName}}.interface';
import { Create{{Name}}Dto, Update{{Name}}Dto } from './dto';
import { {{Name}}Model } from './models/schemas/{{inputName}}.schema';
import { PaginationQueryDto } from '../common/dto/pagination-query.dto';

@Injectable()
export class {{Name}}sService {
  errorContext: string;
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
    @InjectModel({{Name}}Model.name) private readonly userModel: Model<{{Name}}Model>,
  ) {
    this.errorContext = '{{Name}}sModule.{{Name}}sService';
  }

  public async findAll(
    paginationQuery: PaginationQueryDto,
  ): Promise<{{Name}}Model[]> {
    try {
      this.logger.debug(`${this.errorContext}.findAll().begun`);
      const { limit, offset, keyword } = paginationQuery;

      return await this.userModel
        .find()
        .skip(offset)
        .limit(limit)
        //.populate('organization')
        .exec();
    } catch (err) {
      const errorMessage = `${this.errorContext}.findAll().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  public async findOne(userId: string): Promise<{{Name}}Model> {
    try {
      this.logger.debug(`${this.errorContext}.findOne().begun`);
      const {{name}} = await this.userModel
        .findById({ _id: userId })
        //.populate('organization')
        .exec();

      if (!{{name}}) {
        throw new NotFoundException(`{{Name}} #${userId} not found`);
      }
      return {{name}};
    } catch (err) {
      const errorMessage = `${this.errorContext}.findOne().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  public async getByEmail(email: string): Promise<{{Name}}Model> {
    try {
      this.logger.debug(`${this.errorContext}.getByEmail().begun`);
      const {{name}} = await this.userModel
        .findOne({ email: email })
        //.populate('organization')
        .exec();

      if (!{{name}}) {
        throw new NotFoundException(`{{Name}} #${email} not found`);
      }
      return {{name}};
    } catch (err) {
      const errorMessage = `${this.errorContext}.getByEmail().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  public async create(create{{Name}}Dto: Create{{Name}}Dto): Promise<{{Name}}Interface> {
    try {
      this.logger.debug(`${this.errorContext}.create().begun`);
      const new{{Name}} = await new this.userModel(create{{Name}}Dto);
      return new{{Name}}.save();
    } catch (err) {
      const errorMessage = `${this.errorContext}.create().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  public async update(
    userId: string,
    update{{Name}}Dto: Update{{Name}}Dto,
  ): Promise<{{Name}}Interface> {
    try {
      this.logger.debug(`${this.errorContext}.update().begun`);
      const existing{{Name}} = await this.userModel.findByIdAndUpdate(
        { _id: userId },
        update{{Name}}Dto,
      );

      if (!existing{{Name}}) {
        throw new NotFoundException(`{{Name}} #${userId} not found`);
      }

      return existing{{Name}};
    } catch (err) {
      const errorMessage = `${this.errorContext}.update().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  public async remove(userId: string): Promise<any> {
    try {
      this.logger.debug(`${this.errorContext}.remove().begun`);
      const deleted{{Name}} = await this.userModel.findByIdAndRemove(userId);
      return deleted{{Name}};
    } catch (err) {
      const errorMessage = `${this.errorContext}.remove().failed: ${err}`;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }
}
